pragma Ada_95;
pragma Source_File_Name (ada_main, Spec_File_Name => "b~mine_detector.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b~mine_detector.adb");

with System.Restrictions;

package body ada_main is
   pragma Warnings (Off);

   procedure Do_Finalize;
   pragma Import (C, Do_Finalize, "system__standard_library__adafinal");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   procedure adainit is
      E022 : Boolean; pragma Import (Ada, E022, "system__secondary_stack_E");
      E018 : Boolean; pragma Import (Ada, E018, "system__soft_links_E");
      E028 : Boolean; pragma Import (Ada, E028, "system__exception_table_E");
      E190 : Boolean; pragma Import (Ada, E190, "ada__calendar_E");
      E073 : Boolean; pragma Import (Ada, E073, "ada__io_exceptions_E");
      E195 : Boolean; pragma Import (Ada, E195, "ada__numerics_E");
      E171 : Boolean; pragma Import (Ada, E171, "ada__strings_E");
      E060 : Boolean; pragma Import (Ada, E060, "ada__tags_E");
      E058 : Boolean; pragma Import (Ada, E058, "ada__streams_E");
      E010 : Boolean; pragma Import (Ada, E010, "interfaces__c_E");
      E051 : Boolean; pragma Import (Ada, E051, "interfaces__c__strings_E");
      E090 : Boolean; pragma Import (Ada, E090, "system__assertions_E");
      E057 : Boolean; pragma Import (Ada, E057, "system__finalization_root_E");
      E177 : Boolean; pragma Import (Ada, E177, "ada__strings__maps_E");
      E068 : Boolean; pragma Import (Ada, E068, "system__finalization_implementation_E");
      E055 : Boolean; pragma Import (Ada, E055, "ada__finalization_E");
      E053 : Boolean; pragma Import (Ada, E053, "ada__finalization__list_controller_E");
      E173 : Boolean; pragma Import (Ada, E173, "ada__strings__unbounded_E");
      E188 : Boolean; pragma Import (Ada, E188, "field__operations_E");
      E007 : Boolean; pragma Import (Ada, E007, "glib_E");
      E105 : Boolean; pragma Import (Ada, E105, "gdk__rectangle_E");
      E092 : Boolean; pragma Import (Ada, E092, "glib__glist_E");
      E113 : Boolean; pragma Import (Ada, E113, "gdk__visual_E");
      E094 : Boolean; pragma Import (Ada, E094, "glib__gslist_E");
      E101 : Boolean; pragma Import (Ada, E101, "glib__values_E");
      E086 : Boolean; pragma Import (Ada, E086, "gtkada__c_E");
      E080 : Boolean; pragma Import (Ada, E080, "gtkada__bindings_E");
      E088 : Boolean; pragma Import (Ada, E088, "gtkada__types_E");
      E075 : Boolean; pragma Import (Ada, E075, "glib__object_E");
      E111 : Boolean; pragma Import (Ada, E111, "gdk__color_E");
      E154 : Boolean; pragma Import (Ada, E154, "gdk__cursor_E");
      E099 : Boolean; pragma Import (Ada, E099, "glib__generic_properties_E");
      E077 : Boolean; pragma Import (Ada, E077, "glib__type_conversion_hooks_E");
      E134 : Boolean; pragma Import (Ada, E134, "gdk__region_E");
      E103 : Boolean; pragma Import (Ada, E103, "gdk__event_E");
      E156 : Boolean; pragma Import (Ada, E156, "gdk__display_E");
      E107 : Boolean; pragma Import (Ada, E107, "gdk__window_E");
      E138 : Boolean; pragma Import (Ada, E138, "gdk__bitmap_E");
      E136 : Boolean; pragma Import (Ada, E136, "gdk__pixmap_E");
      E142 : Boolean; pragma Import (Ada, E142, "glib__properties_E");
      E115 : Boolean; pragma Import (Ada, E115, "gtk__enums_E");
      E140 : Boolean; pragma Import (Ada, E140, "gtk__object_E");
      E164 : Boolean; pragma Import (Ada, E164, "gtk__accel_group_E");
      E166 : Boolean; pragma Import (Ada, E166, "gtk__adjustment_E");
      E260 : Boolean; pragma Import (Ada, E260, "gtkada__pixmaps_E");
      E128 : Boolean; pragma Import (Ada, E128, "pango__enums_E");
      E146 : Boolean; pragma Import (Ada, E146, "pango__attributes_E");
      E120 : Boolean; pragma Import (Ada, E120, "pango__font_E");
      E130 : Boolean; pragma Import (Ada, E130, "gdk__font_E");
      E132 : Boolean; pragma Import (Ada, E132, "gdk__gc_E");
      E148 : Boolean; pragma Import (Ada, E148, "pango__context_E");
      E150 : Boolean; pragma Import (Ada, E150, "pango__tabs_E");
      E144 : Boolean; pragma Import (Ada, E144, "pango__layout_E");
      E158 : Boolean; pragma Import (Ada, E158, "gdk__drawable_E");
      E160 : Boolean; pragma Import (Ada, E160, "gdk__rgb_E");
      E152 : Boolean; pragma Import (Ada, E152, "gdk__pixbuf_E");
      E117 : Boolean; pragma Import (Ada, E117, "gtk__style_E");
      E109 : Boolean; pragma Import (Ada, E109, "gtk__widget_E");
      E201 : Boolean; pragma Import (Ada, E201, "gtk__arguments_E");
      E205 : Boolean; pragma Import (Ada, E205, "gtk__container_E");
      E209 : Boolean; pragma Import (Ada, E209, "gtk__bin_E");
      E203 : Boolean; pragma Import (Ada, E203, "gtk__box_E");
      E207 : Boolean; pragma Import (Ada, E207, "gtk__button_E");
      E247 : Boolean; pragma Import (Ada, E247, "gtk__grange_E");
      E235 : Boolean; pragma Import (Ada, E235, "gtk__item_E");
      E221 : Boolean; pragma Import (Ada, E221, "gtk__marshallers_E");
      E233 : Boolean; pragma Import (Ada, E233, "gtk__menu_item_E");
      E241 : Boolean; pragma Import (Ada, E241, "gtk__check_menu_item_E");
      E231 : Boolean; pragma Import (Ada, E231, "gtk__menu_shell_E");
      E229 : Boolean; pragma Import (Ada, E229, "gtk__menu_E");
      E227 : Boolean; pragma Import (Ada, E227, "gtk__misc_E");
      E225 : Boolean; pragma Import (Ada, E225, "gtk__label_E");
      E223 : Boolean; pragma Import (Ada, E223, "gtk__notebook_E");
      E253 : Boolean; pragma Import (Ada, E253, "gtk__old_editable_E");
      E237 : Boolean; pragma Import (Ada, E237, "gtk__option_menu_E");
      E239 : Boolean; pragma Import (Ada, E239, "gtk__radio_menu_item_E");
      E245 : Boolean; pragma Import (Ada, E245, "gtk__scrollbar_E");
      E243 : Boolean; pragma Import (Ada, E243, "gtk__scrolled_window_E");
      E249 : Boolean; pragma Import (Ada, E249, "gtk__table_E");
      E251 : Boolean; pragma Import (Ada, E251, "gtk__text_E");
      E213 : Boolean; pragma Import (Ada, E213, "gtk__toggle_button_E");
      E211 : Boolean; pragma Import (Ada, E211, "gtk__check_button_E");
      E217 : Boolean; pragma Import (Ada, E217, "gtk__window_E");
      E215 : Boolean; pragma Import (Ada, E215, "gtk__dialog_E");
      E257 : Boolean; pragma Import (Ada, E257, "gtk__pixmap_E");
      E168 : Boolean; pragma Import (Ada, E168, "user_if_E");

      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Zero_Cost_Exceptions : Integer;
      pragma Import (C, Zero_Cost_Exceptions, "__gl_zero_cost_exceptions");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");

      procedure Install_Handler;
      pragma Import (C, Install_Handler, "__gnat_install_handler");

      Handler_Installed : Integer;
      pragma Import (C, Handler_Installed, "__gnat_handler_installed");
   begin
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, True, False, False, False, False, False, False, 
           False, False, False, False, False, False),
         Value => (0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (False, False, True, True, False, False, False, True, 
           True, True, False, False, True, False, False, True, 
           True, False, True, True, True, True, False, True, 
           False, True, True, False, True, False, False, True, 
           False, False, True, False, False, False, True, False, 
           False, True, False, False, False, False, False, False, 
           False, False, True, True, True, False, False, True, 
           False, True, True, True, True, True, True, False, 
           False, False, False, False, False, False),
         Count => (0, 0, 0, 0, 0, 0, 0),
         Unknown => (False, False, False, False, False, False, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Zero_Cost_Exceptions := 1;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      if Handler_Installed = 0 then
         Install_Handler;
      end if;

      System.Soft_Links'Elab_Body;
      E018 := True;
      System.Secondary_Stack'Elab_Body;
      E022 := True;
      System.Exception_Table'Elab_Body;
      E028 := True;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E190 := True;
      Ada.Io_Exceptions'Elab_Spec;
      E073 := True;
      Ada.Numerics'Elab_Spec;
      E195 := True;
      Ada.Strings'Elab_Spec;
      E171 := True;
      Ada.Tags'Elab_Spec;
      Ada.Streams'Elab_Spec;
      E058 := True;
      Interfaces.C'Elab_Spec;
      E010 := True;
      Interfaces.C.Strings'Elab_Spec;
      E051 := True;
      System.Assertions'Elab_Spec;
      E090 := True;
      System.Finalization_Root'Elab_Spec;
      E057 := True;
      Ada.Strings.Maps'Elab_Spec;
      E177 := True;
      System.Finalization_Implementation'Elab_Spec;
      System.Finalization_Implementation'Elab_Body;
      E068 := True;
      Ada.Finalization'Elab_Spec;
      E055 := True;
      Ada.Finalization.List_Controller'Elab_Spec;
      E053 := True;
      Ada.Strings.Unbounded'Elab_Spec;
      E173 := True;
      Ada.Tags'Elab_Body;
      E060 := True;
      Glib'Elab_Spec;
      E007 := True;
      E105 := True;
      E092 := True;
      Gdk.Visual'Elab_Body;
      E113 := True;
      E094 := True;
      Glib.Values'Elab_Body;
      E101 := True;
      E086 := True;
      E080 := True;
      Gtkada.Types'Elab_Spec;
      E088 := True;
      Glib.Object'Elab_Spec;
      Gdk.Color'Elab_Spec;
      E154 := True;
      Glib.Generic_Properties'Elab_Spec;
      Glib.Generic_Properties'Elab_Body;
      E099 := True;
      E077 := True;
      E075 := True;
      E111 := True;
      E134 := True;
      Gdk.Event'Elab_Spec;
      Gdk.Display'Elab_Spec;
      E156 := True;
      E103 := True;
      E138 := True;
      E136 := True;
      E142 := True;
      E115 := True;
      Gtk.Object'Elab_Spec;
      E140 := True;
      Gtk.Accel_Group'Elab_Spec;
      Gtk.Accel_Group'Elab_Body;
      E164 := True;
      Gtk.Adjustment'Elab_Spec;
      Gtk.Adjustment'Elab_Body;
      E166 := True;
      Gtkada.Pixmaps'Elab_Spec;
      E260 := True;
      E128 := True;
      E146 := True;
      Pango.Font'Elab_Spec;
      E120 := True;
      E130 := True;
      E132 := True;
      Pango.Context'Elab_Spec;
      E148 := True;
      E150 := True;
      Pango.Layout'Elab_Spec;
      E144 := True;
      E158 := True;
      E160 := True;
      E152 := True;
      Gtk.Style'Elab_Spec;
      Gtk.Style'Elab_Body;
      E117 := True;
      Gtk.Widget'Elab_Spec;
      Gtk.Widget'Elab_Body;
      E109 := True;
      E107 := True;
      E201 := True;
      Gtk.Container'Elab_Spec;
      Gtk.Container'Elab_Body;
      E205 := True;
      Gtk.Bin'Elab_Spec;
      Gtk.Bin'Elab_Body;
      E209 := True;
      Gtk.Box'Elab_Spec;
      Gtk.Box'Elab_Body;
      E203 := True;
      Gtk.Button'Elab_Spec;
      Gtk.Button'Elab_Body;
      E207 := True;
      Gtk.Grange'Elab_Spec;
      Gtk.Grange'Elab_Body;
      E247 := True;
      Gtk.Item'Elab_Spec;
      Gtk.Item'Elab_Body;
      E235 := True;
      E221 := True;
      Gtk.Menu_Item'Elab_Spec;
      Gtk.Menu_Item'Elab_Body;
      E233 := True;
      Gtk.Check_Menu_Item'Elab_Spec;
      Gtk.Check_Menu_Item'Elab_Body;
      E241 := True;
      Gtk.Menu_Shell'Elab_Spec;
      Gtk.Menu_Shell'Elab_Body;
      E231 := True;
      Gtk.Menu'Elab_Spec;
      Gtk.Menu'Elab_Body;
      E229 := True;
      Gtk.Misc'Elab_Spec;
      Gtk.Misc'Elab_Body;
      E227 := True;
      Gtk.Label'Elab_Spec;
      Gtk.Label'Elab_Body;
      E225 := True;
      Gtk.Notebook'Elab_Spec;
      Gtk.Notebook'Elab_Body;
      E223 := True;
      Gtk.Old_Editable'Elab_Spec;
      Gtk.Old_Editable'Elab_Body;
      E253 := True;
      Gtk.Option_Menu'Elab_Spec;
      Gtk.Option_Menu'Elab_Body;
      E237 := True;
      Gtk.Radio_Menu_Item'Elab_Spec;
      Gtk.Radio_Menu_Item'Elab_Body;
      E239 := True;
      Gtk.Scrollbar'Elab_Spec;
      Gtk.Scrollbar'Elab_Body;
      E245 := True;
      Gtk.Scrolled_Window'Elab_Spec;
      Gtk.Scrolled_Window'Elab_Body;
      E243 := True;
      Gtk.Table'Elab_Spec;
      Gtk.Table'Elab_Body;
      E249 := True;
      Gtk.Text'Elab_Spec;
      Gtk.Text'Elab_Body;
      E251 := True;
      Gtk.Toggle_Button'Elab_Spec;
      Gtk.Toggle_Button'Elab_Body;
      E213 := True;
      Gtk.Check_Button'Elab_Spec;
      Gtk.Check_Button'Elab_Body;
      E211 := True;
      Gtk.Window'Elab_Spec;
      Gtk.Window'Elab_Body;
      E217 := True;
      Gtk.Dialog'Elab_Spec;
      Gtk.Dialog'Elab_Body;
      E215 := True;
      Gtk.Pixmap'Elab_Spec;
      Gtk.Pixmap'Elab_Body;
      E257 := True;
      User_If'Elab_Body;
      E168 := True;
      Field.Operations'Elab_Body;
      E188 := True;
   end adainit;

   procedure adafinal is
   begin
      Do_Finalize;
   end adafinal;

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure initialize (Addr : System.Address);
      pragma Import (C, initialize, "__gnat_initialize");

      procedure finalize;
      pragma Import (C, finalize, "__gnat_finalize");

      procedure Ada_Main_Program;
      pragma Import (Ada, Ada_Main_Program, "_ada_mine_detector");

      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Break_Start;
      Ada_Main_Program;
      Do_Finalize;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/mine_detector-6.0/field.o
   --   /builddir/build/BUILD/mine_detector-6.0/user_if.o
   --   /builddir/build/BUILD/mine_detector-6.0/field-operations.o
   --   /builddir/build/BUILD/mine_detector-6.0/mine_detector.o
   --   -L/builddir/build/BUILD/mine_detector-6.0/
   --   -L/usr/lib64/pragmarc/
   --   -L/usr/lib64/gtkada/static/
   --   -L/usr/lib/gcc/ppc64-redhat-linux/4.4.3/adalib/
   --   -shared
   --   -lgnat-4.4
--  END Object file/option list   

end ada_main;
